Attribute VB_Name = "Module1"
Option Explicit

Public Function RotatedTextOut(ByVal Text As String, _
                               ByRef Dest As Object, _
                               ByVal xDest As Double, _
                               ByVal yDest As Double, _
                               ByVal Angle As Double, _
                               Optional ByVal Backcolor As Long = -1 _
                               ) As Long
    
    ' Standalone-Funktion zur Ausgabe von gedrehtem Text.
    ' Geeignet, um mal schnell eine vertikale Achsbeschriftung zu
    ' erstellen. Nur fr 90-Schritte geeignet und nicht zeitoptimiert.
    ' Antialiasing wird bercksichtigt. Kommt ohne API und sonstige
    ' Tricks aus.
    
    ' Autor/Copyright: K. Langbein, ActiveVB.de, 2007
    
    On Error GoTo err1
    
    Dim Frm As Object
    Dim Pic As Object
    Dim sm As Long
    Dim th As Long
    Dim tw As Long
    Dim Col() As Long
    Dim x() As Long
    Dim y() As Long
    Dim bk As Long
    Dim i As Long
    Dim j As Long
    Dim n As Long
    Dim Alpha As Double
    Dim SinA As Double
    Dim CosA As Double
    Dim Xi As Double
    Dim Yi As Double
    Dim dw As Long
    Const RPD = 1.74532925199433E-02  ' Radian pro Grad (=Pi/180)
    
    sm = Dest.ScaleMode
    dw = Dest.DrawWidth
    Dest.DrawWidth = 1
    Dest.ScaleMode = 3
    
    ' Es wird eine Form als Container fr die temporre Picturebox bentigt
    If TypeOf Dest Is Form Then
        Set Frm = Dest
    Else
        Set Frm = Dest.Parent
    End If
    
    ' Temporre Picturebox erzeugen und Eigenschaften einstellen
    Set Pic = Frm.Controls.Add("VB.Picturebox", "Pic", Frm)
    Set Pic.Font = Dest.Font
    Pic.AutoRedraw = True
    Pic.BorderStyle = 0
    Pic.Appearance = 0
    Pic.ScaleMode = 3
    Pic.ForeColor = Dest.ForeColor
    
    'Gre der Picturebox anpassen
    tw = Pic.TextWidth(Text)
    th = Pic.TextHeight(Text)
    Pic.Width = Dest.ScaleX(tw + 1, 3, Frm.ScaleMode)
    Pic.Height = Dest.ScaleY(th + 1, 3, Frm.ScaleMode)
    n = Pic.ScaleWidth * Pic.ScaleHeight + 1 ' Anzahl der Pixel + Reserve
    ReDim x(n)
    ReDim y(n)
    ReDim Col(n)
    
    'Pic.Visible = True     ' nur zur Kontrolle einschalten
    
    If Backcolor = -1 Then  ' Falls transparenter Text ausgegeben werden soll,
        bk = Dest.Backcolor ' bernehmen wir die Hintergundfarbe des Ziel-DC.
    Else
        bk = Backcolor      ' Ansonsten die gewnschte Farbe,
    End If
    Pic.Backcolor = bk
    'Pic.Cls
    
    ' Textausgabe in temporrer Picturebox
    Pic.Print Text
    
    ' Farb- und Ortsinformation speichern
    n = 0
    For j = 0 To Pic.ScaleHeight - 1
        For i = 0 To Pic.ScaleWidth - 1
            n = n + 1
            x(n) = i
            y(n) = j
            Col(n) = Pic.Point(i, j)
        Next i
    Next j
    
    ' Winkel einstellen:         ' bergabe von +90 bedeutet Drehung
    Alpha = -Angle * RPD         ' gegen Uhrzeigersinn
    SinA = Sin(Alpha)            ' Sinus und Kosinus Vorberechnen
    CosA = Cos(Alpha)
    
    ' Koordinatentransformation (Rotation)
    If Alpha <> 0 Then ' Drehung wird nur bentigt, wenn Alpha<>0
        For i = 1 To n
            Xi = x(i)
            Yi = y(i)
            x(i) = CLng(CosA * Xi - SinA * Yi)
            y(i) = CLng(SinA * Xi + CosA * Yi)
        Next i
    End If
    
    ' Ausgabeort in Pixeln Berechnen
    Xi = CLng(Dest.ScaleX(xDest, sm, 3))
    Yi = CLng(Dest.ScaleY(yDest, sm, 3))
    
    ' Ausgabe der gedrehten Pixel
    If Backcolor <> -1 Then
        For i = 1 To n
            Dest.PSet (Xi + x(i), Yi + y(i)), Col(i)
        Next i
    Else
        For i = 1 To n           ' Wenn transparent, dann nur Pixel des Textes
            If Col(i) <> bk Then ' bercksichtigen
                Dest.PSet (Xi + x(i), Yi + y(i)), Col(i)
            End If
        Next i
    End If
    
exi: ' Rcksprungmarke nach Fehlerbehandlung
    
    ' Scalemode zurcksetzen und Objekte lschen
    Dest.ScaleMode = sm
    Dest.DrawWidth = dw
    Frm.Controls.Remove Pic
    Set Pic = Nothing
    
    Exit Function
    
err1:
    Select Case Err
    Case 438
        RotatedTextOut = Err
        GoTo exi
    Case Else
        RotatedTextOut = Err
        'Resume
        MsgBox Error$
        GoTo exi
    End Select
                        
End Function

